/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.DataElements;

import java.text.SimpleDateFormat;

/**
 * \class JSDateFormat
 *
 * \brief Datumsformate
 *
 * \details
 *
 * \section JSDateFormat.java_intro_sec Introduction
 *
 * \section JSDateFormat.java_samples Some Samples
 *
 * \code
 *   .... code goes here ...
 * \endcode
 *
 * <p style="text-align:center">
 * <br />---------------------------------------------------------------------------
 * <br /> APL/Software GmbH - Berlin
 * <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
 * <br />---------------------------------------------------------------------------
 * </p>
 * \author EQCPN
* @version $Id: JSDateFormat.java 14731 2011-07-05 20:50:42Z sos $12.03.2009
 * \see reference
 *
 * Created on 12.03.2009 12:23:03
 */

public class JSDateFormat extends SimpleDateFormat {
	/**
	 *
	 */
	private static final long	serialVersionUID	= -2570993909578952179L;
	public static JSDateFormat	dfTIMESTAMP			= new JSDateFormat("yyyyMMddhhmmssS");
	public static JSDateFormat	dfTIMESTAMPS		= new JSDateFormat("yyyyMMddhhmmss");
	public static JSDateFormat	dfTIMESTAMPS24		= new JSDateFormat("yyyyMMddHHmmss");
	public static JSDateFormat	dfAMERCICAN			= new JSDateFormat("MM/dd/yyyy");
	public static JSDateFormat	dfAMERCICAN_SHORT	= new JSDateFormat("MM/dd/yy");
	public static JSDateFormat	dfGERMAN			= new JSDateFormat("dd.MM.yyyy");
	public static JSDateFormat	dfGERMAN_SHORT		= new JSDateFormat("dd.MM.yy");
	public static JSDateFormat	dfGERMAN_TIME		= new JSDateFormat("dd.MM.yyyy' 'HH:mm:ss");
	public static JSDateFormat	dfDATE				= new JSDateFormat("yyyy-MM-dd");
	public static JSDateFormat	dfDATE_SHORT		= new JSDateFormat("yyyy-MM-dd");
	public static JSDateFormat	dfDATE_N8			= new JSDateFormat("yyyyMMdd");
	public static JSDateFormat	dfDATE_N6			= new JSDateFormat("yyMMdd");
	public static JSDateFormat	dfTIME				= new JSDateFormat("HH:mm:ss");
	public static JSDateFormat	dfTIME_EXT			= new JSDateFormat("HH:mm:ss.S");
	public static JSDateFormat	dfISO				= new JSDateFormat("yyyy-MM-dd'T'HH:mm:ss");
	public static JSDateFormat	dfISO_EXT			= new JSDateFormat("yyyy-MM-dd'T'hh:mm:ss.S");
	public static JSDateFormat	dfWEEK		 		= new JSDateFormat("ww");
	public static JSDateFormat	dfYEAR_WEEK			= new JSDateFormat("yyyy-ww");
	public static JSDateFormat	dfWEEK_YEAR			= new JSDateFormat("ww/yyyy");

	public JSDateFormat(final String pstrFormat) {
		super(pstrFormat);
	}


}
