/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosprof.h                                                    (c) SOS GmbH Berlin

#ifndef __SOSPROF_H
#define __SOSPROF_H

namespace sos
{

void                            set_sos_ini_filename    ( const string& filename );

string                          read_profile_string     ( const char* filename, const char* group_name, const char* entry_name, const char* default_result = "" );
bool                            read_profile_bool       ( const char* filename, const char* group_name, const char* entry_name, bool def );
int                             read_profile_int        ( const char* filename, const char* group_name, const char* entry_name, int def = 0 );
uint                            read_profile_uint       ( const char* filename, const char* group_name, const char* entry_name, uint def = 0 );
double                          read_profile_double     ( const char* filename, const char* group_name, const char* entry_name, double def = 0.0 );
bool                            read_profile_entry      ( Area*, const char* filename, const char* group_name, const char* entry_name, const char* default_result = "" );
string                          read_existing_profile_string( const char* filename, const char* group_name, const char* entry_name );

inline string read_profile_string( const char* filename, const char* group_name, const char* entry_name, const string& default_result )
{
    return read_profile_string( filename, group_name, entry_name, default_result.c_str() );
}

inline string                   read_profile_string     ( const string& filename, const string& group_name, const string& entry_name, const string& default_result = "" )   { return read_profile_string( filename.c_str(), group_name.c_str(), entry_name.c_str(), default_result.c_str() ); }
inline bool                     read_profile_bool       ( const string& filename, const string& group_name, const string& entry_name, bool def )                            { return read_profile_bool  ( filename.c_str(), group_name.c_str(), entry_name.c_str(), def ); }
inline int                      read_profile_int        ( const string& filename, const string& group_name, const string& entry_name, int def = 0 )                         { return read_profile_int   ( filename.c_str(), group_name.c_str(), entry_name.c_str(), def ); }
inline uint                     read_profile_uint       ( const string& filename, const string& group_name, const string& entry_name, uint def = 0 )                        { return read_profile_uint  ( filename.c_str(), group_name.c_str(), entry_name.c_str(), def ); }
inline double                   read_profile_double     ( const string& filename, const string& group_name, const string& entry_name, double def = 0.0 )                    { return read_profile_double( filename.c_str(), group_name.c_str(), entry_name.c_str(), def ); }


void                            write_profile_bool      ( bool, const char* filename, const char* group_name, const char* entry_name );
void                            write_profile_uint      ( uint, const char* filename, const char* group_name, const char* entry_name, int def = 0 );
void                            write_profile_string    ( const string&, const char* filename, const char* group_name, const char* entry_name );
void                            write_profile_entry     ( const Const_area&, const char* filename, const char* group_name, const char* entry_name );
void                            write_profile           ( const char* filename, const char* section, const char* entry, const char* value );


} //namespace sos

#endif
