/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sysxcept.h                           (c) SOS GmbH Berlin
// $Id: sysxcept.h 11394 2005-04-03 08:30:29Z jz $

// 1693

#ifndef __SYSXCEPT_H
#define __SYSXCEPT_H

#if !defined __SYSDEP_H
#    include "sysdep.h"
#endif

#if !defined __SOSSTRNG_H
#   include "sosstrng.h"
#endif

#if defined __BORLANDC__

#   if !defined __XCEPT_H
#       include <except.h>
#   endif

#   if !defined __TYPEINFO_H
#       define Type_info __Type_info__
#       include <typeinfo.h>
#       undef Type_info
#   endif

#   if !defined __BORSTRNG_H
#       include <borstrng.h>
#   endif

    inline const char* exception_name( const xmsg& x )
    {
        //return typeid( x ).name();
        return z::name_of_type( x );
    }

    inline const char* exception_text( const xmsg& x ) { return c_str( x.why() ); }

    typedef xmsg exception;

#elif defined SYSTEM_SOLARISxxx // 22.7.01

#   include <exception.h>

    namespace sos {

    inline const char* exception_name( const xmsg& x )        // der Name der aktuellen Exception wird geliefert!
    {
        //return exception_name();      // 3.0
        //return "UNKNOWN";               // 4.0
	    return x.why();			// 4.2	js 16/7/97
    }

    inline const char* exception_text( const xmsg& x ) { return "(exception)"; }

    // typedef xmsg exception; js 10.10.96: kollidiert mit <math.h>

    } //namespace sos

#elif defined SYSTEM_MICROSOFT

//# include <eh.h>         // terminate() und unexpected()
#   include <stdexcpt.h>
#   include <typeinfo.h>

    namespace sos 
    {
        string             exception_name( const exception& x ); //  { return typeid( x ).name(); }
        inline const char* exception_text( const exception& x )  { return x.what(); }

        typedef exception xmsg;
    } //namespace sos

#else

#   include <exception>       // GNU gcc 3
    using std::exception;

    namespace sos 
    {
        //struct exception {};

      //inline const char* exception_name( const exception& )  { return "(gnuexception)"; }
        string             exception_name( const exception& x );
        inline const char* exception_text( const exception& x )  { return x.what(); }
        //inline const char* exception_text( const exception& )  { return "(Exception)"; }

        //typedef xmsg exception;
    } //namespace sos

#endif

namespace sos
{
    // Die Namen sind obsolet:
    //inline const char* name( const exception& x ) { return exception_name( x ); }
    //inline const char* text( const exception& x ) { return exception_text(x); }
}

#endif
