/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: embedded_files.h 14010 2010-09-13 08:05:23Z jz $

#ifndef __ZSCHIMMER__INLINE_FILES_H
#define __ZSCHIMMER__INLINE_FILES_H

/**
* \change 2.0.224 - jira-XXX: Dynamisch eingebundes XSD verwenden
* \detail
*/
#include <vector>

namespace zschimmer {

    //------------------------------------------------------------------------------------Embedded_file

    struct Embedded_file
    { 
        const char*                _filename;
        const char*                _content;
        int                        _length; 
        time_t                     _last_modified_time;
    };

    //-----------------------------------------------------------------------------------Embedded_files

    struct Embedded_files
    { 
        const Embedded_file*        get_embedded_file           ( const string& filename ) const;
        const Embedded_file*        get_embedded_file_or_null   ( const string& filename ) const;
        string                      string_from_embedded_file   ( const string& filename ) const;

        const Embedded_file*       _embedded_files;
    };

    /**
    * \change 2.0.224 - jira-XXX: Dynamisch eingebundenes XSD verwenden
    * \detail
    */
    struct Dynamic_file
    { 
        string                     _filename;
        string*                    _content;
        int                        _length; 
        time_t                     _last_modified_time;
    };

    /**
    * \change 2.0.224 - jira-XXX: Dynamisch eingebundes XSD verwenden
    * \detail
    */
    struct Embedded_and_dynamic_files // : public Embedded_files
    {
        string                          string_from_embedded_file   ( const string& filename );
        void                            set_dynamic_file            ( string& filename, const string key );
        const Embedded_files           _embedded_files;
        std::vector<Dynamic_file*>*    _dynamic_files;
    };

    //-------------------------------------------------------------------------------------------------


    //-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
