/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// zschimmer.h                                      2000 Joacim Zschimmer
// $Id: not_in_recursion.h 13691 2008-09-30 20:42:20Z jz $

#ifndef __ZSCHIMMER_NOT_IN_RECURSION_H
#define __ZSCHIMMER_NOT_IN_RECURSION_H

#include "log.h"

namespace zschimmer {
          
//--------------------------------------------------------------------------------Recursion_count
    
//struct Recursion_count
//{
//                                Prefix_log_deny_recursion   ( int* count_ptr )                    : _count_ptr( count_ptr ) { (*count_ptr)++; }
//                               ~Prefix_log_deny_recursion   ()                                      { _count_ptr--; }
//
//                                operator const int          ()                                      { return *_count_ptr; }
//
//    int* const                 _count_ptr;
//};

//-------------------------------------------------------------------------------------In_recursion
    
struct Not_in_recursion : Non_cloneable
{
    Not_in_recursion( int* recursion_count_ptr )
    :
        _previous_recursion_count( (*recursion_count_ptr)++ ),
        _recursion_count_ptr( recursion_count_ptr )
    { 
        if( _previous_recursion_count )  Z_LOG2( "zschimmer", "***" << Z_FUNCTION << "  In recursion ***\n" );
    }

    Not_in_recursion( const Not_in_recursion& r )
    :
        _previous_recursion_count( r._previous_recursion_count ),
        _recursion_count_ptr( NULL )
    {
    }

    ~Not_in_recursion()
    { 
        release();
    }

    void release()
    {
        if( _recursion_count_ptr )  (*_recursion_count_ptr)--, _recursion_count_ptr = NULL;
    }

    operator bool()
    { 
        return _previous_recursion_count == 0;
    }


  private:
    int  const _previous_recursion_count;
    int*       _recursion_count_ptr;
};

//
// Funktioniert nicht mit gcc 3.4.3, weil der einen Kopierkonstruktor verlangt: if( Not_in_recursion n = &x )   

//struct Not_in_recursion : Non_cloneable
//{
//    Not_in_recursion( int* recursion_count_ptr )
//    :
//        _recursion_count_ptr( recursion_count_ptr ) 
//    { 
//        (*recursion_count_ptr)++;
//    }
//
//    ~Not_in_recursion()
//    { 
//        (*_recursion_count_ptr)--;
//    }
//
//    operator bool()
//    { 
//        return *_recursion_count_ptr == 1;
//    }
//
//
//  private:
//    int* const _recursion_count_ptr;
//};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif


