/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: threads_base.cxx 13322 2008-01-27 15:27:19Z jz $

#include "zschimmer.h"
#include "mutex.h"
#include "threads_base.h"
#include "log.h"


namespace zschimmer {


//--------------------------------------------------------------------------Event_base::~Event_base

Event_base::~Event_base()
{
}

//------------------------------------------------------------------------------Event_base::as_text

string Event_base::as_text() const
{ 
    string result = "Event " + _name; 
    if( _signaled  &&  !_signal_name.empty() )  result += " \"" + _signal_name + "\"";
    return result;
}

//--------------------------------------------------------------------Thread_base::thread_call_main

void Thread_base::thread_call_main()
{ 
    thread_init();
    int exit_code = call_thread_main();  
    thread_exit( exit_code ); 
}

//--------------------------------------------------------------------Thread_base::call_thread_main

int Thread_base::call_thread_main()
{
    try
    {
        Z_LOG( "Thread " << _thread_name << " startet\n" );

        int ret = thread_main();

        Z_LOG( "Thread " << _thread_name << " beendet\n" );

        return ret;
    }
    catch( const exception& x )
    {
        string msg = "\n\n*** Thread " + /*as_string(thread_id()) + " " +*/ thread_name() + " bricht mit Fehler ab: " + x.what() + "***\n\n\n";
        Z_LOG( msg.c_str() );
        fputs( msg.c_str(), stderr );
        return 99;
    }
}

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer
